Attribute VB_Name = "Module1"

Option Explicit

' BROWSEINFO\
Private Type srtBrowseInfo
    hWnd            As Long
    pidlRoot        As Long
    szDisplayName   As String
    szTitle         As String
    lnFlags         As Long
    lnPFunc         As Long
    lParam          As Long
    lnImage         As Long
End Type


'//////////////////////////////////////////
'֐錾
'//////////////////////////////////////////
Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
                  Alias "SHBrowseForFolderA" (lpBrowseInfo As srtBrowseInfo) _
                  As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" _
                  Alias "SHGetPathFromIDListA" (ByVal pidl As Long, _
                  ByVal pszPath As String) As Long
Private Declare Function SHFree Lib "shell32" _
                  Alias "#195" (ByVal pidl As Long) As Long


Private Declare Function SendMessage Lib "user32" _
                  Alias "SendMessageA" _
                 (ByVal hWnd As Long, _
                  ByVal wMsg As Long, _
                  ByVal wParam As Long, _
                  lParam As Any) As Long

'//////////////////////////////////////////
'萔`
'//////////////////////////////////////////

Private Const CSIDL_DESKTOP = &H0                               ' fXNgbv
Private Const CSIDL_PROGRAMS = &H2                              ' vO
Private Const CSIDL_CONTROLS = &H3                              ' Rg[pl
Private Const CSIDL_PRINTERS = &H4                              ' v^
Private Const CSIDL_PERSONAL = &H5                              ' p[\i
Private Const CSIDL_FAVORITES = &H6                             ' ubN}[N
Private Const CSIDL_STARTUP = &H7                               ' X^[gAbv
Private Const CSIDL_RECENT = &H8                                ' [ŋߎgt@C]
Private Const CSIDL_SENDTO = &H9                                ' []
Private Const CSIDL_BITBUCKET = &HA
Private Const CSIDL_STARTMENU = &HB                             ' [X^[g]j[
Private Const CSIDL_DESKTOPDIRECTORY = &H10                     ' fXNgbv
Private Const CSIDL_DRIVES = &H11
Private Const CSIDL_NETWORK = &H12
Private Const CSIDL_NETHOO = &H13                               ' Network Neighborhood
Private Const CSIDL_FONTS = &H14                                ' tHg
Private Const CSIDL_TEMPLATES = &H15                            ' Shell New

Private Const BIF_RETURNONLYFSDIRS = &H1&                       ' tH_̂ݑI\ɂ܂B
Private Const BIF_DONTGOBELOWDOMAIN = &H2&                      ' lbg[ÑRs[^\B̃tOƑgݍ킹B
Private Const BIF_STATUSTEXT = &H4&                             ' _CAOɃXe[^X\܂B
Private Const BIF_RETURNFSANCESTORS = &H8&
Private Const BIF_BROWSEFORCOMPUTER = &H1000&                   ' lbg[NRs[^ȉ̃Rs[^̂ݑI\B
Private Const BIF_BROWSEFORPRINTER = &H2000&                    ' v^[̂ݑI\ɂ܂B
Private Const BIF_BROWSEINCLUDEFILES = &H4000&                  ' SđI\ɂ܂B

'' R[obN֐󂯎郁bZ[W
Private Const BFFM_INITIALIZED           As Long = &H1&         ' _CAOꂽ
Private Const BFFM_SELCHANGED            As Long = &H2&         ' ACeIꂽ
'' R[obN֐tH_Qƃ_CAOɑ郁bZ[W
Private Const BFFM_SETSTATUSTEXTA        As Long = &H464&       ' Xe[^XeLXgݒ肷
Private Const BFFM_ENABLEOK              As Long = &H465&       ' OK {^̎gpۂݒ肷
Private Const BFFM_SETSELECTIONA         As Long = &H466&       ' ACeI

'//////////////////////////////////////////
'Privateϐ
'//////////////////////////////////////////
Private pr_szDefaultPath                As String

'=========================================================================================
' R[obNꂽbZ[WɂăbZ[W𑗂B
'=========================================================================================
Private Function ZpfBrowseCallbackProc(ByVal hWnd As Long, _
                                    ByVal uMsg As Long, _
                                    ByVal lParam As Long, _
                                    ByVal lnData As Long) As Long
    Select Case uMsg
        Case BFFM_INITIALIZED
            ' ItH_ݒ肷B
            Call SendMessage(hWnd, _
                             BFFM_SETSELECTIONA, _
                             1&, _
                             ByVal pr_szDefaultPath)
        Case Else
    End Select
End Function

'=========================================================================================
'|C^̂܂ܓnB
'=========================================================================================
Private Function ZpfGetFarProc(lnPointerFunc As Long) As Long
    ' AddressOf͕WW[̃vV[Ww肵Ȃ΂ȂȂ̂BꂪB
    ZpfGetFarProc = lnPointerFunc
End Function

'=========================================================================================
' tH_̑I_CAO\B
'=========================================================================================
Public Function ShowSelectFolderDialog(ByVal hWnd As Long, _
                              ByVal szPrompt As String, _
                              ByVal szDefaultPath As String) As String

    Dim srtBrInfo       As srtBrowseInfo
    Dim lnPid           As Long
    Dim szPath          As String * 1024

    pr_szDefaultPath = szDefaultPath
    srtBrInfo.hWnd = hWnd
    srtBrInfo.pidlRoot = 0                      ' 0̓fXNgbvB
    srtBrInfo.szTitle = szPrompt                ' _CAOɕ\vvgZbgB
    srtBrInfo.lnFlags = BIF_RETURNONLYFSDIRS    ' tOlZbgB
    ' R[obNɎgp郁\bhZbgB
    srtBrInfo.lnPFunc = ZpfGetFarProc(AddressOf ZpfBrowseCallbackProc)


    ' _CAO\B
    lnPid = SHBrowseForFolder(srtBrInfo)

    If lnPid <> 0 Then
        ' lnPidpXɕϊB
        If SHGetPathFromIDList(lnPid, szPath) Then
            ' pXoB
            ShowSelectFolderDialog = Left$(szPath, InStr(szPath, vbNullChar) - 1)
        End If
    End If

    ' lnPidJB
    Call SHFree(lnPid)
End Function



