// ApiPrtCtrl.cpp :  STARFAX API
// 

#include "stdafx.h"

#include	"ApiPrtCtrl.h"

extern "C" {

/////////////////////////////////////////////////////////////////////////////
// 萔`

// STARFAX WXgTuL[
#define	SFCS_LMKEY_SFCS			"Software\\MEGASOFT\\SfCs"

/////////////////////////////////////////////////////////////////////////////
// }N`

// (S-JIS)̂PoCgځH
#define	CheckDBS(c) ((0x80<=((unsigned char)c)&&((unsigned char)c)<=0x9f)||(0xe0<=((unsigned char)c)&&((unsigned char)c)<=0xfe))

/////////////////////////////////////////////////////////////////////////////
// \̒`

/////////////////////////////////////////////////////////////////////////////
// ֐`

// t@Cǂݍ݉\mF
static BOOL	SUB_CheckReadFile( char *pFileName );

//**********************************************************************
// ֐        : SFCSENV_GetSvcRegPathString
// @\          : STARFAX WXgpX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SFCSENV_GetSvcRegPathString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
//           : pKey     = L[
//               : pDefault = ftHg
//               : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
DWORD APIENTRY	SFCSENV_GetSvcRegPathString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	HKEY	hKey = NULL; 
	DWORD	dwType;

	ZeroMemory( pGet, dwBufLen );
	if( ERROR_SUCCESS == RegOpenKeyEx( HKEY_LOCAL_MACHINE, SFCS_LMKEY_SFCS, 0, KEY_READ, &hKey ) ) {
		RegQueryValueEx( hKey, pKey, NULL, &dwType, (BYTE*)pGet, &dwBufLen );
		RegCloseKey( hKey );
		dwRet = lstrlen( pGet );
	}
	else {
		if( pDefault ) {
			lstrcpy( pGet, pDefault );
			dwRet = lstrlen( pGet );
		}
		goto	EXIT;
	}

	if( dwRet ) {

		// Ō'\\'  

		char	*pChk = pGet;
		char	*pEnd = pGet + lstrlen( pGet );

		for( ; pChk < pEnd ; pChk++ ) {
			if( *pChk == '\\' && ( pChk == ( pEnd  - 1 ) ) ) {
				*pChk = 0x00;
				dwRet--;
				break;
			}
			if( CheckDBS( *pChk ) ) {
				pChk++;
			}			
		}
	}

EXIT:

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSENV_WriteSvcRegPathString
// @\          : STARFAX WXgpXݒ
// Ăяo      : BOOL APIENTRY SFCSENV_WriteSvcRegPathString( char *pKey, char *pString )
//           : pKey     = L[
//               : pString  = ݒ蕶
// o          : Ԓl  TRUE:  FALSE: s
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
BOOL APIENTRY	SFCSENV_WriteSvcRegPathString( char *pKey, char *pString )
{
	return SFCSENV_WriteSvcRegString( pKey, pString );
}

//**********************************************************************
// ֐        : SFCSENV_GetSvcRegString
// @\          : STARFAX WXg擾
// Ăяo      : DWORD APIENTRY SFCSENV_GetSvcRegString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
//           : pKey     = L[
//               : pDefault = ftHg
//               : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
DWORD APIENTRY	SFCSENV_GetSvcRegString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	HKEY	hKey = NULL; 
	DWORD	dwType;

	ZeroMemory( pGet, dwBufLen );
	if( ERROR_SUCCESS == RegOpenKeyEx( HKEY_LOCAL_MACHINE, SFCS_LMKEY_SFCS, 0, KEY_READ, &hKey ) ) {
		RegQueryValueEx( hKey, pKey, NULL, &dwType, (BYTE*)pGet, &dwBufLen );
		RegCloseKey( hKey );
		dwRet = lstrlen( pGet );
	}
	else {
		if( pDefault ) {
			lstrcpy( pGet, pDefault );
			dwRet = lstrlen( pGet );
		}
	}

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSENV_WriteSvcRegString
// @\          : STARFAX WXgݒ
// Ăяo      : BOOL APIENTRY SFCSENV_WriteSvcRegString( char *pKey, char *pString )
//           : pKey     = L[
//               : pString  = ݒ蕶
// o          : Ԓl  TRUE:  FALSE: s
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
BOOL APIENTRY	SFCSENV_WriteSvcRegString( char *pKey, char *pString )
{
	BOOL	bRet = FALSE;
	HKEY	hKey = NULL; 
	DWORD	dwDisposition;

	// Gg[L[I[v͍쐬
	if( ERROR_SUCCESS == RegCreateKeyEx(
		HKEY_LOCAL_MACHINE ,
		SFCS_LMKEY_SFCS,
		0,
		NULL,
		REG_OPTION_NON_VOLATILE,
		KEY_WRITE,
		NULL,
		&hKey,
		&dwDisposition ) ) {

		if( ERROR_SUCCESS == RegSetValueEx( hKey, pKey, 0, REG_SZ, (unsigned char *)pString, lstrlen( pString ) + 1 ) ) {
			bRet = TRUE;
		}

		RegCloseKey( hKey );
	}

	return bRet;
}

//**********************************************************************
// ֐        : SFCSENV_GetSvcRegInt
// @\          : STARFAX WXgl擾
// Ăяo      : DWORD APIENTRY SFCSENV_GetSvcRegInt( char *pKey, DWORD dwDefault )
//           : pKey      = L[
//               : dwDefault = ftHgl
// o          : Ԓl  WXgl
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
DWORD APIENTRY	SFCSENV_GetSvcRegInt( char *pKey, DWORD dwDefault )
{
	DWORD	dwRet = dwDefault;

	HKEY	hKey = NULL; 
	DWORD	dwType;
	DWORD	dwBufLen = sizeof(DWORD);

	if( ERROR_SUCCESS == RegOpenKeyEx( HKEY_LOCAL_MACHINE, SFCS_LMKEY_SFCS, 0, KEY_READ, &hKey ) ) {
		dwType = REG_DWORD;					// WXgL[̐ݒ
		RegQueryValueEx( hKey, pKey, NULL, &dwType, (BYTE*)&dwRet, &dwBufLen );
		RegCloseKey( hKey );
	}

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSENV_WriteRegInt
// @\          : STARFAX WXglݒ
// Ăяo      : BOOL APIENTRY SFCSENV_WriteRegInt( char *pKey, DWORD dwSet )
//           : pKey   = L[
//               : dwSet  = ݒ萔l
// o          : Ԓl  TRUE:  FALSE: s
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
BOOL APIENTRY	SFCSENV_WriteRegInt( char *pKey, DWORD dwSet )
{
	BOOL	bRet = FALSE;
	HKEY	hKey = NULL; 
	DWORD	dwDisposition;

	// Gg[L[I[v͍쐬
	if( ERROR_SUCCESS == RegCreateKeyEx(
		HKEY_LOCAL_MACHINE ,
		SFCS_LMKEY_SFCS,
		0,
		NULL,
		REG_OPTION_NON_VOLATILE,
		KEY_WRITE,
		NULL,
		&hKey,
		&dwDisposition ) ) {

		if( ERROR_SUCCESS == RegSetValueEx( hKey, pKey, 0, REG_DWORD, (BYTE *)&dwSet, sizeof(DWORD) ) ) {
			bRet = TRUE;
		}

		RegCloseKey( hKey );
	}

	return bRet;
}

//**********************************************************************
// ֐        : SFCSPRN_ClearOutFolder
// @\          : STARFAX : t@Co̓tH_̃NA
// Ăяo      : BOOL APIENTRY SFCSPRN_ClearOutFolder( char *pOutFolder, char *pDocName )
//           : pOutFolder = t@Co̓tH_
//               : pDocName   = hLg
// o          : Ԓl  TRUE:  NA
//               :       FALSE: NAs
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
BOOL APIENTRY	SFCSPRN_ClearOutFolder( char *pOutFolder, char *pDocName )
{
	BOOL	bRet = TRUE;
	WIN32_FIND_DATA	FindData;
	HANDLE	hOutFolder;

	char	szWild[MAX_PATH+1];
	char	szGetFile[MAX_PATH+1];

	wsprintf( szWild, "%s\\%s*.*", pOutFolder, pDocName );
	FindData.dwFileAttributes = FILE_ATTRIBUTE_NORMAL;
	hOutFolder = FindFirstFile( (LPCTSTR) szWild, (LPWIN32_FIND_DATA) &FindData );
	if( hOutFolder != INVALID_HANDLE_VALUE ) {

NEXT:

		if( !( FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM ) && 
			!( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ) { 

			wsprintf( szGetFile, "%s\\%s", pOutFolder, FindData.cFileName );

			if( !SUB_CheckReadFile( szGetFile ) ) {
				bRet = FALSE;
				goto	STEP_CANSEL;
			}
			DeleteFile( szGetFile );
			bRet = TRUE;
		}

		if( FindNextFile( hOutFolder, &FindData ) ) {
			goto	NEXT;
		}

	STEP_CANSEL:

	    FindClose( hOutFolder );
	}

	return bRet;
}

//**********************************************************************
// ֐        : SFCSPRN_GetPrintFileName
// @\          : STARFAX : t@Co̓tH_̈t@C̎擾
// Ăяo      : BOOL APIENTRY SFCSPRN_GetPrintFileName( char *pOutFolder, char *pDocName, char *pGetFileName )
//           : pOutFolder   = t@Co̓tH_
//               : pDocName     = hLg
//               : pGetFileName = 擾t@C
// o          : Ԓl  TRUE:  ʗL
//               :       FALSE: ʖ
// L      : 
// 쐬        : 
// 쐬        : 2005.12.06
//**********************************************************************
BOOL APIENTRY	SFCSPRN_GetPrintFileName( char *pOutFolder, char *pDocName, char *pGetFileName )
{
	BOOL	bRet = FALSE;
	WIN32_FIND_DATA	FindData;
	HANDLE	hOutFolder;

	char	szWild[MAX_PATH+1];
	char	szGetFile[MAX_PATH+1];

	wsprintf( szWild, "%s\\%s*.*", pOutFolder, pDocName );
	FindData.dwFileAttributes = FILE_ATTRIBUTE_NORMAL;
	hOutFolder = FindFirstFile( (LPCTSTR) szWild, (LPWIN32_FIND_DATA) &FindData );
	if( hOutFolder != INVALID_HANDLE_VALUE ) {

NEXT:

		if( !( FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM ) && 
			!( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ) { 

			wsprintf( szGetFile, "%s\\%s", pOutFolder, FindData.cFileName );

			if( SUB_CheckReadFile( szGetFile ) ) {
				lstrcpy( pGetFileName, szGetFile );
				bRet = TRUE;
				goto	STEP_CANSEL;
			}
		}

		if( FindNextFile( hOutFolder, &FindData ) ) {
			goto	NEXT;
		}

	STEP_CANSEL:

	    FindClose( hOutFolder );
	}

	return bRet;
}

//**********************************************************************
// ֐        : 
// @\          : t@Cǂݍ݉\mF
// Ăяo      : 
//           :      = 
// o          : Ԓl  
// L      : 
// 쐬        : 
// 쐬        : 2003.06.05
//**********************************************************************
static BOOL	SUB_CheckReadFile( char *pFileName )
{
	BOOL	bRet = FALSE;	// l͎s

	HANDLE	hFil = INVALID_HANDLE_VALUE;

	if( ( hFil = CreateFile( pFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ) != INVALID_HANDLE_VALUE ) {

		CloseHandle( hFil );

		bRet = TRUE;
	} 

	return bRet;
}

}
